import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot)
import java.util.*;
/**
 * @author Miftah Reza 
 * @version 1.1
 */
public class Hunter  extends Actor
{
    //Inisiasi variable bebas
    private int ShootTimer = 0;
    
    public void act() 
    {
       List bullets = getNeighbours(3, false, Shit.class);
       if (!bullets.isEmpty()) { //Cuma ada 1 peluru yang muncul di layar
       Actor b = (Actor) bullets.get(0); //Numbak pelurunya kena musuh
       if (b instanceof Shit) { //Kondisi mengecek peluru milik si pemburu
           getWorld().removeObject(b); //Menghilangkan peluru setelah mengenai musuh
           destroy(); //Menghancurkan musuh
       }
       } else {
        processKeys();
       }
    }    
    
    /**
     * Keyboard Input.
     */
    private void processKeys() {
        //Method untuk mengerakan si pemburu
        int x = getX();
        if(Greenfoot.isKeyDown("right")) {
            x = x+1; //Bergerak ke kanan
            setLocation(x, getY());
        }
        if(Greenfoot.isKeyDown("left")) {
            x = x-1; //Bergerak ke kiri
            setLocation(x, getY());
        }
        if (Greenfoot.isKeyDown("up") && ((Farm) getWorld()).CanShoot()) {
            //Method untuk menembak yaitu pencet atas
            getWorld().addObject(new Bullet(), getX(), getY()-5);
            ((Farm) getWorld()).ShootSet(0);
            Greenfoot.playSound("shoot2.wav");
        }   
    }

    private void destroy() {
        //Method jika si pemburu kena tembak
        getWorld().addObject(new HunterDie(), getX(), getY());
        ((Farm) getWorld()).ShootSet(0);
        Greenfoot.playSound("pain.wav"); //Kalo kena tembak ada suranya
        getWorld().removeObject(this);
    }
}
