import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot)

/**
 * @author Miftah Reza 
 * @version 1.1
 */
public class HunterDie  extends Actor
{
    private int deathtimer = 0; //Timer untuk me-remove object
    
    private GreenfootImage img1;
    private GreenfootImage img2;
    
    public HunterDie() //Animasi ketika si pemburu kena tembak
    {
        img1 = getImage(); //Gambar sekarang
        img2 = new GreenfootImage("pemburu3.png"); //Gambar kedua
    }

    public void act() 
    {
        //Method yang berisikan kondisi si pemburu ketika tertembak akan berkedip
        deathtimer++;
        if (deathtimer > 20) {
            ((Farm) getWorld()).die();
            getWorld().removeObject(this);
        } else {
            if (getImage() == img1) {
                setImage(img2);
            } else {
                setImage(img1);
            }
        }
            
    }    
}
